#include "font.h"
#include <phongmaterial.h>

Font::Font()
{

}

Mesh* Font::getTextMesh(std::string s, glm::vec3 color)
{
    Mesh* text =  new Mesh();
    glm::ivec2 current_pos;
    for(char c : s){
        if(c == '\n')
        {
            current_pos.x = 0; // left alignment -> TODO : be able to center or align right
            current_pos.y += m_lineHeight;
        }
        else
        {
            CharInfo charInfo = m_charTable[c];
            text->addRectangle2D(current_pos + charInfo.offset,
                                 charInfo.dim,
                                 glm::vec2(charInfo.pos)/m_scale,
                                 glm::vec2(charInfo.dim)/m_scale);
            current_pos.x += charInfo.xadvance;
        }
    }
    PhongMaterial *mat = new PhongMaterial();
    // TODO : delete this material somewhere (garbage collector ?)
    mat->setTexture(PhongMaterial::ALPHA_SLOT, m_tex, "font_texture");
    mat->diffuse = color;
    text->setMaterial((Material*)mat);
    text->initGL();
    return text;
}
